#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request; 

&get_setup;
$q = CGI->new;



acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n"; 

$ccid = $q->param('ccid');
$fnumber = $q->param('fnumber');


$finfilename = $ccid . "_" . $fnumber . ".fin";

if (-e "$data_dir/crawler/$finfilename") ### IF FINISHED CRAWL
	{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT count(*) FROM crawlresults WHERE ccid = '$ccid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";} 

while ( @row = $sth->fetchrow() )
	{
	$cnumber = $row[0];
	} 

$sth = $dbh->prepare("UPDATE crawlcats SET linksnumber = '$cnumber' WHERE ccid = '$ccid'");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";} 

$sth->finish;
$dbh->disconnect;  

$filen =  $fnumber . "_" . $ccid . "_.url";
$currenturl = acs::get_file_contents("$data_dir/crawler/$filen");
@aimtes = split (/\n/, $currenturl);
$crawlitems = @aimtes;

print qq[
<html>
<head>
<title>Crawl Complete</title>
</head>
<body>

<table border="0" cellpadding="3" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="100%" valign="top"><font face="Verdana" size="1"><strong>Thread $fnumber has
    finished crawling. Crawled $crawlitems Links. Nothing more to be done.</strong></font></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];

### CLEANUP

		opendir(DIR,"$data_dir/crawler");
		@files2 = readdir(DIR);
		closedir(DIR);

		$fn2 = $fnumber . "_" . $ccid . "_.stat";
		$fn3 = $ccid . "_" . $fnumber . ".fin";
		$fnurl = $fnumber . "_" . $ccid . "_.url";
		foreach $filename (@files2)
			{
			if ($filename eq $fn2){$tmp = unlink("$data_dir/crawler/$fn2");}
			if ($filename eq $fnurl){$tmp = unlink("$data_dir/crawler/$fnurl");}
			if ($filename eq $fn3){$tmp = unlink("$data_dir/crawler/$fn3");}
			
				if (substr($filename, length($filename) - 4, 4) eq "urls")
					{ 
					($tmpcid, $tmp, $tmp2) = split (/_/, $filename);
						if ($tmpcid eq $ccid)
							{
							$tmp = unlink("$data_dir/crawler/$filename");
							}
					}
			}




	
	}
	else
	{
	$towrite_status_fname = $fnumber . "_" . $ccid . "_.stat";
	$currenturl = acs::get_file_contents("$data_dir/crawler/$towrite_status_fname");
	
	if ($currenturl ne "") { $fetching = "Now Fetching <font color=\"#0000FF\"><strong>$currenturl</strong></font>"; }

	$crit1 = chr(10);
	$crit2 = chr(13);  
	
	$currenturl =~ s/\n//g; $currenturl =~ s/$crit1//g; $currenturl =~ s/$crit2//g;

	### GET PERCENT COMPLETE
	$filen =  $fnumber . "_" . $ccid . "_.url";
	$allurls = acs::get_file_contents("$data_dir/crawler/$filen");
	@aimtes = split (/\n/, $allurls);
	$crawlitems = @aimtes;

	$icnt = 0;
	foreach $item (@aimtes)
		{
		if ($currenturl eq $item)
			{
			$current_nr = $icnt;
			}
		
		$icnt++;
		}

	if ($current_nr > 0)
		{
		$perc = ($current_nr / $crawlitems) * 100;
		$perc = sprintf("%5.2f",$perc);
		
		$percbox = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="100%" valign="top" colspan="3"><strong><font face="Verdana" size="1">Thread
    $fnumber Crawling... Please Wait...</font><font face="Arial" size="4"><strong><br>
    </strong></font></strong><font face="Verdana" size="1">$fetching</font></td>
  </tr>
  <tr>
    <td width="1%" valign="top"><img src="$web_url/working2.gif"></td>
    <td width="20%" valign="middle" align="center"><strong><font face="Verdana" size="1">$perc
    % Complete</font></strong></td>
    <td width="79%" valign="middle" align="left"><hr noshade size="8" color="#0000A0"
    width="$perc%" align="left">
    </td>
  </tr>
</table>];
		
		}
		else
		{

		$percbox = qq[

<table border="0" cellpadding="0" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="100%" valign="top"><strong><font face="Verdana" size="1">Thread $fnumber
    Crawling... Please Wait...</font><font face="Arial" size="4"><strong><br>
    </strong></font></strong><font face="Verdana" size="1">$fetching</font></td>
  </tr>
  <tr>
    <td width="100%" valign="top"><img src="$web_url/working2.gif"></td>
  </tr>
</table>

		];
				
		
		}


#<meta http-equiv="refresh" content="5">
print qq[
<html>
<head>
<title>Crawling</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="5;URL=$admin_url/pcrawl6.cgi?ccid=$ccid&fnumber=$fnumber">
</head>
<body>

$percbox
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];
	
	}








#########################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

